- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Ogre::HardwareBuffer Class Reference

Abstract class defining common features of hardware buffers. More...

`#include <OgreHardwareBuffer.h>`

Inheritance diagram for Ogre::HardwareBuffer:
[legend]

List of all members.

## Public Types
enum | Usage { HBU_STATIC = 1, HBU_DYNAMIC = 2, HBU_WRITE_ONLY = 4, HBU_DISCARDABLE = 8, HBU_STATIC_WRITE_ONLY = 5, HBU_DYNAMIC_WRITE_ONLY = 6, HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE = 14 }
| Enums describing buffer usage; not mutually exclusive. More...
enum | LockOptions { HBL_NORMAL, HBL_DISCARD, HBL_READ_ONLY, HBL_NO_OVERWRITE }
| Locking options. More...
## Public Member Functions
| HardwareBuffer (Usage usage, bool systemMemory, bool useShadowBuffer)
| Constructor, to be called by HardwareBufferManager only.
virtual | ~HardwareBuffer ()
virtual void * | lock (size_t offset, size_t length, LockOptions options)
| Lock the buffer for (potentially) reading / writing.
void * | lock (LockOptions options)
| Lock the entire buffer for (potentially) reading / writing.
virtual void | unlock (void)
| Releases the lock on this buffer.
virtual void | readData (size_t offset, size_t length, void *pDest)=0
| Reads data from the buffer and places it in the memory pointed to by pDest.
virtual void | writeData (size_t offset, size_t length, const void *pSource, bool discardWholeBuffer=false)=0
| Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.
virtual void | copyData (HardwareBuffer &srcBuffer, size_t srcOffset, size_t dstOffset, size_t length, bool discardWholeBuffer=false)
| Copy data from another buffer into this one.
virtual void | _updateFromShadow (void)
| Updates the real buffer from the shadow buffer, if required.
size_t | getSizeInBytes (void) const
| Returns the size of this buffer in bytes.
Usage | getUsage (void) const
| Returns the Usage flags with which this buffer was created.
bool | isSystemMemory (void) const
| Returns whether this buffer is held in system memory.
bool | hasShadowBuffer (void) const
| Returns whether this buffer has a system memory shadow for quicker reading.
bool | isLocked (void) const
| Returns whether or not this buffer is currently locked.
void | suppressHardwareUpdate (bool suppress)
| Pass true to suppress hardware upload of shadow buffer changes.
## Protected Member Functions
virtual void * | lockImpl (size_t offset, size_t length, LockOptions options)=0
| Internal implementation of lock().
virtual void | unlockImpl (void)=0
| Internal implementation of unlock().
## Protected Attributes
size_t | mSizeInBytes
Usage | mUsage
bool | mIsLocked
size_t | mLockStart
size_t | mLockSize
bool | mSystemMemory
bool | mUseShadowBuffer
HardwareBuffer * | mpShadowBuffer
bool | mShadowUpdated
bool | mSuppressHardwareUpdate

## Detailed Description

Abstract class defining common features of hardware buffers.

Remarks:
  A 'hardware buffer' is any area of memory held outside of core system ram, and in our case refers mostly to video ram, although in theory this class could be used with other memory areas such as sound card memory, custom coprocessor memory etc.

  This reflects the fact that memory held outside of main system RAM must be interacted with in a more formal fashion in order to promote cooperative and optimal usage of the buffers between the various processing units which manipulate them.

  This abstract class defines the core interface which is common to all buffers, whether it be vertex buffers, index buffers, texture memory or framebuffer memory etc.

  Buffers have the ability to be 'shadowed' in system memory, this is because the kinds of access allowed on hardware buffers is not always as flexible as that allowed for areas of system memory - for example it is often either impossible, or extremely undesirable from a performance standpoint to read from a hardware buffer; when writing to hardware buffers, you should also write every byte and do it sequentially. In situations where this is too restrictive, it is possible to create a hardware, write-only buffer (the most efficient kind) and to back it with a system memory 'shadow' copy which can be read and updated arbitrarily. Ogre handles synchronising this buffer with the real hardware buffer (which should still be created with the HBU_DYNAMIC flag if you intend to update it very frequently). Whilst this approach does have it's own costs, such as increased memory overhead, these costs can often be outweighed by the performance benefits of using a more hardware efficient buffer. You should look for the 'useShadowBuffer' parameter on the creation methods used to create the buffer of the type you require (see HardwareBufferManager) to enable this feature.

Definition at line 68 of file OgreHardwareBuffer.h.

## Member Enumeration Documentation

enum Ogre::HardwareBuffer::Usage

Enums describing buffer usage; not mutually exclusive.

Enumerator:

  HBU_STATIC | Static buffer which the application rarely modifies once created. Modifying the contents of this buffer will involve a performance hit.
  HBU_DYNAMIC | Indicates the application would like to modify this buffer with the CPU fairly often. Buffers created with this flag will typically end up in AGP memory rather than video memory.
  HBU_WRITE_ONLY | Indicates the application will never read the contents of the buffer back, it will only ever write data. Locking a buffer with this flag will ALWAYS return a pointer to new, blank memory rather than the memory associated with the contents of the buffer; this avoids DMA stalls because you can write to a new memory area while the previous one is being used.
  HBU_DISCARDABLE | Indicates that the application will be refilling the contents of the buffer regularly (not just updating, but generating the contents from scratch), and therefore does not mind if the contents of the buffer are lost somehow and need to be recreated. This allows and additional level of optimisation on the buffer. This option only really makes sense when combined with HBU_DYNAMIC_WRITE_ONLY.
  HBU_STATIC_WRITE_ONLY | Combination of HBU_STATIC and HBU_WRITE_ONLY.
  HBU_DYNAMIC_WRITE_ONLY | Combination of HBU_DYNAMIC and HBU_WRITE_ONLY. If you use this, strongly consider using HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE instead if you update the entire contents of the buffer very regularly.
  HBU_DYNAMIC_WRITE_ONLY_DISCARDABLE | Combination of HBU_DYNAMIC, HBU_WRITE_ONLY and HBU_DISCARDABLE.

Definition at line 73 of file OgreHardwareBuffer.h.

enum Ogre::HardwareBuffer::LockOptions

Locking options.

Enumerator:

  HBL_NORMAL | Normal mode, ie allows read/write and contents are preserved.
  HBL_DISCARD | Discards the entire buffer while locking; this allows optimisation to be performed because synchronisation issues are relaxed. Only allowed on buffers created with the HBU_DYNAMIC flag.
  HBL_READ_ONLY | Lock the buffer for reading only. Not allowed in buffers which are created with HBU_WRITE_ONLY. Mandatory on statuc buffers, ie those created without the HBU_DYNAMIC flag.
  HBL_NO_OVERWRITE | As HBL_NORMAL, except the application guarantees not to overwrite any region of the buffer which has already been used in this frame, can allow some optimisation on some APIs.

Definition at line 115 of file OgreHardwareBuffer.h.

## Constructor & Destructor Documentation

Ogre::HardwareBuffer::HardwareBuffer | ( | Usage | usage,
|  | bool | systemMemory,
|  | bool | useShadowBuffer |
| ) |  |  |

Constructor, to be called by HardwareBufferManager only.

Definition at line 153 of file OgreHardwareBuffer.h.

virtual Ogre::HardwareBuffer::~HardwareBuffer | ( |  | ) | `[virtual]`

Definition at line 168 of file OgreHardwareBuffer.h.

## Member Function Documentation

virtual void* Ogre::HardwareBuffer::lockImpl | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options |
| ) |  |  | `[protected, pure virtual]`

Internal implementation of lock().

Implemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

virtual void Ogre::HardwareBuffer::unlockImpl | ( | void |  | ) | `[protected, pure virtual]`

Internal implementation of unlock().

Implemented in Ogre::DefaultHardwareVertexBuffer, and Ogre::DefaultHardwareIndexBuffer.

virtual void* Ogre::HardwareBuffer::lock | ( | size_t | offset,
|  | size_t | length,
|  | LockOptions | options |
| ) |  |  | `[virtual]`

Lock the buffer for (potentially) reading / writing.

Parameters:

  | offset | The byte offset from the start of the buffer to lock
  | length | The size of the area to lock, in bytes
  | options | Locking options

Returns:
  Pointer to the locked memory

Reimplemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

Definition at line 175 of file OgreHardwareBuffer.h.

Referenced by copyData().

void* Ogre::HardwareBuffer::lock | ( | LockOptions | options | ) |

Lock the entire buffer for (potentially) reading / writing.

Parameters:

  | options | Locking options

Returns:
  Pointer to the locked memory

Definition at line 205 of file OgreHardwareBuffer.h.

virtual void Ogre::HardwareBuffer::unlock | ( | void |  | ) | `[virtual]`

Releases the lock on this buffer.

Remarks:
  Locking and unlocking a buffer can, in some rare circumstances such as switching video modes whilst the buffer is locked, corrupt the contents of a buffer. This is pretty rare, but if it occurs, this method will throw an exception, meaning you must re-upload the data.

  Note that using the 'read' and 'write' forms of updating the buffer does not suffer from this problem, so if you want to be 100% sure your data will not be lost, use the 'read' and 'write' forms instead.

Reimplemented in Ogre::DefaultHardwareVertexBuffer, and Ogre::DefaultHardwareIndexBuffer.

Definition at line 221 of file OgreHardwareBuffer.h.

Referenced by copyData().

virtual void Ogre::HardwareBuffer::readData | ( | size_t | offset,
|  | size_t | length,
|  | void * | pDest |
| ) |  |  | `[pure virtual]`

Reads data from the buffer and places it in the memory pointed to by pDest.

Parameters:

  | offset | The byte offset from the start of the buffer to read
  | length | The size of the area to read, in bytes
  | pDest | The area of memory in which to place the data, must be large enough to accommodate the data!

Implemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

virtual void Ogre::HardwareBuffer::writeData | ( | size_t | offset,
|  | size_t | length,
|  | const void * | pSource,
|  | bool | discardWholeBuffer = `false` |
| ) |  |  | `[pure virtual]`

Writes data to the buffer from an area of system memory; note that you must ensure that your buffer is big enough.

Parameters:

  | offset | The byte offset from the start of the buffer to start writing
  | length | The size of the data to write to, in bytes
  | pSource | The source of the data to be written
  | discardWholeBuffer | If true, this allows the driver to discard the entire buffer when writing, such that DMA stalls can be avoided; use if you can.

Implemented in Ogre::DefaultHardwareVertexBuffer, Ogre::DefaultHardwareIndexBuffer, and Ogre::HardwarePixelBuffer.

virtual void Ogre::HardwareBuffer::copyData | ( | HardwareBuffer & | srcBuffer,
|  | size_t | srcOffset,
|  | size_t | dstOffset,
|  | size_t | length,
|  | bool | discardWholeBuffer = `false` |
| ) |  |  | `[virtual]`

Copy data from another buffer into this one.

Remarks:
  Note that the source buffer must not be created with the usage HBU_WRITE_ONLY otherwise this will fail.

Parameters:

  | srcBuffer | The buffer from which to read the copied data
  | srcOffset | Offset in the source buffer at which to start reading
  | dstOffset | Offset in the destination buffer to start writing
  | length | Length of the data to copy, in bytes.
  | discardWholeBuffer | If true, will discard the entire contents of this buffer before copying

Definition at line 269 of file OgreHardwareBuffer.h.

References lock(), and unlock().

virtual void Ogre::HardwareBuffer::_updateFromShadow | ( | void |  | ) | `[virtual]`

Updates the real buffer from the shadow buffer, if required.

Definition at line 279 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::getSizeInBytes | ( | void |  | ) | const

Returns the size of this buffer in bytes.

Definition at line 304 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::getUsage | ( | void |  | ) | const

Returns the Usage flags with which this buffer was created.

Definition at line 306 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isSystemMemory | ( | void |  | ) | const

Returns whether this buffer is held in system memory.

Definition at line 308 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::hasShadowBuffer | ( | void |  | ) | const

Returns whether this buffer has a system memory shadow for quicker reading.

Definition at line 310 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::isLocked | ( | void |  | ) | const

Returns whether or not this buffer is currently locked.

Definition at line 312 of file OgreHardwareBuffer.h.

void Ogre::HardwareBuffer::suppressHardwareUpdate | ( | bool | suppress | ) |

Pass true to suppress hardware upload of shadow buffer changes.

Definition at line 316 of file OgreHardwareBuffer.h.

## Member Data Documentation

size_t Ogre::HardwareBuffer::mSizeInBytes`[protected]`

Definition at line 135 of file OgreHardwareBuffer.h.

Usage Ogre::HardwareBuffer::mUsage`[protected]`

Definition at line 136 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mIsLocked`[protected]`

Definition at line 137 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockStart`[protected]`

Definition at line 138 of file OgreHardwareBuffer.h.

size_t Ogre::HardwareBuffer::mLockSize`[protected]`

Definition at line 139 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSystemMemory`[protected]`

Definition at line 140 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mUseShadowBuffer`[protected]`

Definition at line 141 of file OgreHardwareBuffer.h.

HardwareBuffer* Ogre::HardwareBuffer::mpShadowBuffer`[protected]`

Definition at line 142 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mShadowUpdated`[protected]`

Definition at line 143 of file OgreHardwareBuffer.h.

bool Ogre::HardwareBuffer::mSuppressHardwareUpdate`[protected]`

Definition at line 144 of file OgreHardwareBuffer.h.

The documentation for this class was generated from the following file:

- OgreHardwareBuffer.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Mon Jun 16 12:49:54 2008